Index: c/src/lib/libbsp/powerpc/mpc55xxevb/preinstall.am
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/preinstall.am	(revision 243596d65e9fc5541fc731c8ad7fc3fdc0bcaf9b)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/preinstall.am	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
@@ -86,7 +86,19 @@
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/irq-config.h
 
+$(PROJECT_INCLUDE)/bsp/smsc9218i.h: include/smsc9218i.h $(PROJECT_INCLUDE)/bsp/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/bsp/smsc9218i.h
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/smsc9218i.h
+
 $(PROJECT_INCLUDE)/bsp/irq-generic.h: ../../shared/include/irq-generic.h $(PROJECT_INCLUDE)/bsp/$(dirstamp)
 	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/bsp/irq-generic.h
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/irq-generic.h
+
+$(PROJECT_INCLUDE)/bsp/irq-info.h: ../../shared/include/irq-info.h $(PROJECT_INCLUDE)/bsp/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/bsp/irq-info.h
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/irq-info.h
+
+$(PROJECT_INCLUDE)/bsp/utility.h: ../../shared/include/utility.h $(PROJECT_INCLUDE)/bsp/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/bsp/utility.h
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/utility.h
 
 $(PROJECT_INCLUDE)/bsp/tictac.h: ../shared/include/tictac.h $(PROJECT_INCLUDE)/bsp/$(dirstamp)
Index: c/src/lib/libbsp/powerpc/mpc55xxevb/startup/bspstart.c
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/startup/bspstart.c	(revision 243596d65e9fc5541fc731c8ad7fc3fdc0bcaf9b)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/startup/bspstart.c	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
@@ -93,9 +93,38 @@
 static void mpc55xx_ebi_init()
 {
-	struct EBI_CS_tag cs = { BR : MPC55XX_ZERO_FLAGS, OR : MPC55XX_ZERO_FLAGS };
+	struct EBI_CS_tag cs = { .BR = MPC55XX_ZERO_FLAGS, .OR = MPC55XX_ZERO_FLAGS };
 	union SIU_PCR_tag pcr = MPC55XX_ZERO_FLAGS;
+	struct MMU_tag mmu = MMU_DEFAULT;
 	int i = 0;
 
-	/* External SRAM (0 wait states, 512kB, 4 word burst) */
+	/* ADDR [8 : 31] */
+	for (i = 4; i < 4 + 24; ++i) {
+		SIU.PCR [i].R = 0x440;
+	}
+
+	/* DATA [0 : 15] */
+	for (i = 28; i < 28 + 16; ++i) {
+		SIU.PCR [i].R = 0x440;
+	}
+
+	/* RD_!WR */
+	SIU.PCR [62].R = 0x443;
+
+	/* !BDIP */
+	SIU.PCR [63].R = 0x443;
+
+	/* !WE [0 : 3] */
+	for (i = 64; i < 64 + 4; ++i) {
+		SIU.PCR [i].R = 0x443;
+	}
+
+	/* !OE */
+	SIU.PCR [68].R = 0x443;
+
+	/* !TS */
+	SIU.PCR [69].R = 0x443;
+
+	/* External SRAM (2 wait states, 512kB, 4 word burst) */
+
 	cs.BR.B.BA = 0;
 	cs.BR.B.PS = 1;
@@ -115,30 +144,42 @@
 	SIU.PCR [0].R = 0x443;
 
-	/* ADDR [8 : 31] */
-	for (i = 4; i < 4 + 24; ++i) {
-		SIU.PCR [i].R = 0x440;
-	}
-
-	/* DATA [0 : 15] */
-	for (i = 28; i < 28 + 16; ++i) {
-		SIU.PCR [i].R = 0x440;
-	}
-
-	/* RD_!WR */
-	SIU.PCR [62].R = 0x443;
-
-	/* !BDIP */
-	SIU.PCR [63].R = 0x443;
-
-	/* !WE [0 : 3] */
-	for (i = 64; i < 64 + 4; ++i) {
-		SIU.PCR [i].R = 0x443;
-	}
-
-	/* !OE */
-	SIU.PCR [68].R = 0x443;
-
-	/* !TS */
-	SIU.PCR [69].R = 0x443;
+	/* External Ethernet Controller (3 wait states, 64kB) */
+
+	mmu.MAS0.B.ESEL = 5;
+	mmu.MAS1.B.VALID = 1;
+	mmu.MAS1.B.IPROT = 1;
+	mmu.MAS1.B.TSIZ = 1;
+	mmu.MAS2.B.EPN = 0x3fff8;
+	mmu.MAS2.B.I = 1;
+	mmu.MAS2.B.G = 1;
+	mmu.MAS3.B.RPN = 0x3fff8;
+	mmu.MAS3.B.UW = 1;
+	mmu.MAS3.B.SW = 1;
+	mmu.MAS3.B.UR = 1;
+	mmu.MAS3.B.SR = 1;
+
+	PPC_SET_SPECIAL_PURPOSE_REGISTER( FREESCALE_EIS_MAS0, mmu.MAS0.R);
+	PPC_SET_SPECIAL_PURPOSE_REGISTER( FREESCALE_EIS_MAS1, mmu.MAS1.R);
+	PPC_SET_SPECIAL_PURPOSE_REGISTER( FREESCALE_EIS_MAS2, mmu.MAS2.R);
+	PPC_SET_SPECIAL_PURPOSE_REGISTER( FREESCALE_EIS_MAS3, mmu.MAS3.R);
+
+	asm volatile ("tlbwe");
+
+	cs.BR.B.BA = 0x7fff;
+	cs.BR.B.PS = 1;
+	cs.BR.B.BL = 0;
+	cs.BR.B.WEBS = 0;
+	cs.BR.B.TBDIP = 0;
+	cs.BR.B.BI = 1;
+	cs.BR.B.V = 1;
+
+	cs.OR.B.AM = 0x1ffff;
+	cs.OR.B.SCY = 1;
+	cs.OR.B.BSCY = 0;
+
+	EBI.CS [3] = cs;
+
+	/* !CS [3] */
+	SIU.PCR [3].R = 0x443;
 }
 
@@ -199,5 +240,6 @@
 	}
 	
-	RTEMS_DEBUG_PRINT( "BSP start done\n");
+	/* Initialize eMIOS */
+	mpc55xx_emios_initialize( 1);
 
 	return;
Index: c/src/lib/libbsp/powerpc/mpc55xxevb/startup/sd-card-init.c
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/startup/sd-card-init.c	(revision 243596d65e9fc5541fc731c8ad7fc3fdc0bcaf9b)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/startup/sd-card-init.c	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
@@ -19,5 +19,5 @@
  */
 
-#include  <stdio.h>
+#include <stdio.h>
 
 #include <mpc55xx/mpc55xx.h>
@@ -25,11 +25,7 @@
 #include <mpc55xx/dspi.h>
 
-#include <libchip/spi-sd-card.h>
-
-#define DEBUG
+#include <bsp.h>
 
 #include <rtems/status-checks.h>
-
-#include <bsp.h>
 
 static rtems_status_code mpc55xx_dspi_init(void)
@@ -89,14 +85,11 @@
 }
 
-#include <sys/types.h>
-#include <sys/stat.h>
-#include <unistd.h>
-#include <fcntl.h>
-#include <dirent.h>
 #include <stdio.h>
 #include <rtems/fsmount.h>
 #include <rtems/dosfs.h>
-#include <rtems/ide_part_table.h>
+#include <rtems/bdpart.h>
 #include <rtems/console.h>
+
+#include <libchip/spi-sd-card.h>
 
 #define MPC55XX_DEVICE "sd-card-a"
@@ -118,19 +111,8 @@
 };
 
-#define SD_CARD_NUMBER 1
-
-sd_card_driver_entry sd_card_driver_table [SD_CARD_NUMBER] = { {
-#if 0
-		.driver = {
-			.ops = &sd_card_driver_ops,
-			.size = sizeof( sd_card_driver_entry)
-		},
-		.table_index = 0,
-		.minor = 0,
-#endif
-		.device_name = "sd-card-a",
-#if 0
-		.disk_device_name = "/dev/sd-card-a",
-#endif
+sd_card_driver_entry sd_card_driver_table [] = {
+	{
+		.device_name = "/dev/sd-card-a",
+		.bus = 0,
 		.transfer_mode = SD_CARD_TRANSFER_MODE_DEFAULT,
 		.command = SD_CARD_COMMAND_DEFAULT,
@@ -141,11 +123,13 @@
 		.block_size = 0,
 		.block_size_shift = 0,
-		.busy = 1,
-		.verbose = 1,
-		.schedule_if_busy = 0,
+		.busy = true,
+		.verbose = true,
+		.schedule_if_busy = false
 	}
 };
 
-rtems_status_code mpc55xx_sd_card_init(void)
+size_t sd_card_driver_table_size = sizeof( sd_card_driver_table) / sizeof( sd_card_driver_table [0]);
+
+rtems_status_code mpc55xx_sd_card_init( bool mount)
 {
 	rtems_status_code sc = RTEMS_SUCCESSFUL;
@@ -158,15 +142,16 @@
 	RTEMS_CHECK_SC( rv, "Intitalize DSPI bus");
 
-	rv = rtems_libi2c_register_drv( e->device_name, (rtems_libi2c_drv_t *) e, mpc55xx_dspi_bus_table [0].bus_number, 0);
-	RTEMS_CHECK_RV_SC( rv, "Register SD Card driver");
+	e->bus = mpc55xx_dspi_bus_table [0].bus_number;
 
-	sc = rtems_ide_part_table_initialize( MPC55XX_DEVICE_FILE);
-	RTEMS_CHECK_SC( sc, "Initialize IDE partition table");
+	sc = sd_card_register();
+	RTEMS_CHECK_SC( sc, "Register SD Card");
 
-	rv = mkdir( MPC55XX_MOUNT_POINT, S_IRWXU);
-	RTEMS_CHECK_RV_SC( rv, "Create mount point");
+	if (mount) {
+		sc = rtems_bdpart_register_from_disk( MPC55XX_DEVICE_FILE);
+		RTEMS_CHECK_SC( sc, "Initialize IDE partition table");
 
-	rv = rtems_fsmount( mpc55xx_fs_table, sizeof( mpc55xx_fs_table) / sizeof( mpc55xx_fs_table [0]), NULL);
-	RTEMS_CHECK_RV_SC( rv, "Mount file systems");
+		rv = rtems_fsmount( mpc55xx_fs_table, sizeof( mpc55xx_fs_table) / sizeof( mpc55xx_fs_table [0]), NULL);
+		RTEMS_CHECK_RV_SC( rv, "Mount file systems");
+	}
 
 	return RTEMS_SUCCESSFUL;
Index: c/src/lib/libbsp/powerpc/mpc55xxevb/tests/tests.c
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/tests/tests.c	(revision 243596d65e9fc5541fc731c8ad7fc3fdc0bcaf9b)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/tests/tests.c	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
@@ -37,6 +37,4 @@
 #include <libcpu/powerpc-utility.h>
 
-/* #define DEBUG */
-
 #include <rtems/status-checks.h>
 
@@ -217,5 +215,8 @@
 
 	printk( "Boot time: %u\n", ppc_time_base());
+
+	/*
 	test_mpc55xx_intc( 0);
+	*/
 
 	rv = rtems_libi2c_initialize();
@@ -269,5 +270,5 @@
 		rtems_build_name ( 'P', 'I', 'N', 'G'),
 		1,
-		RTEMS_SIMPLE_BINARY_SEMAPHORE | RTEMS_INHERIT_PRIORITY | RTEMS_PRIORITY,
+		RTEMS_SIMPLE_BINARY_SEMAPHORE | RTEMS_PRIORITY,
 		RTEMS_NO_PRIORITY,
 		&test_mpc55xx_dspi_ping
@@ -278,5 +279,5 @@
 		rtems_build_name ( 'P', 'O', 'N', 'G'),
 		0,
-		RTEMS_SIMPLE_BINARY_SEMAPHORE | RTEMS_INHERIT_PRIORITY | RTEMS_PRIORITY,
+		RTEMS_SIMPLE_BINARY_SEMAPHORE | RTEMS_PRIORITY,
 		RTEMS_NO_PRIORITY,
 		&test_mpc55xx_dspi_pong
@@ -326,4 +327,6 @@
 	RTEMS_CHECK_SC( sc, "rtems_task_start");
 
+	return RTEMS_SUCCESSFUL;
+
 	rtems_id intc_id;
 	sc = rtems_task_create(
@@ -339,9 +342,8 @@
 	RTEMS_CHECK_SC( sc, "rtems_task_start");
 
-	sc = rtems_task_delete( RTEMS_SELF);
-	RTEMS_CHECK_SC( sc, "rtems_task_delete");
-
 	return RTEMS_SUCCESSFUL;
 }
+
+#if 0
 
 #include <sys/types.h>
@@ -422,33 +424,4 @@
 }
 
-#define SD_CARD_NUMBER 1
-
-static sd_card_driver_entry sd_card_driver_table_XXX [SD_CARD_NUMBER] = { {
-#if 0
-		driver : {
-			ops : &sd_card_driver_ops,
-			size : sizeof( sd_card_driver_entry)
-		},
-		table_index : 0,
-		minor : 0,
-#endif
-		device_name : "sd-card-a",
-#if 0
-		disk_device_name : "/dev/sd-card-a",
-#endif
-		transfer_mode : SD_CARD_TRANSFER_MODE_DEFAULT,
-		command : SD_CARD_COMMAND_DEFAULT,
-		/* response : whatever, */
-		response_index : SD_CARD_COMMAND_SIZE,
-		n_ac_max : SD_CARD_N_AC_MAX_DEFAULT,
-		block_number : 0,
-		block_size : 0,
-		block_size_shift : 0,
-		busy : 1,
-		verbose : 1,
-		schedule_if_busy : 0,
-	}
-};
-
 rtems_task test_sd_card( rtems_task_argument arg)
 {
@@ -485,15 +458,17 @@
 	RTEMS_CHECK_SC_TASK( sc, "Initialize IDE partition table");
 
+	rv = mkdir( TEST_SD_CARD_MOUNT_POINT, S_IRWXU);
+	RTEMS_CHECK_RV_TASK( rv, "Create mount point");
+
+	rv = rtems_fsmount( test_sd_card_fs_table, sizeof( test_sd_card_fs_table) / sizeof( test_sd_card_fs_table [0]), NULL);
+	RTEMS_CHECK_RV_TASK( rv, "Mount file systems");
+
 	rv = test_sd_card_print_dir( "/dev", 0);
 	RTEMS_CHECK_RV_TASK( rv, "Print directory");
 
-	rv = mkdir( TEST_SD_CARD_MOUNT_POINT, S_IRWXU);
-	RTEMS_CHECK_RV_TASK( rv, "Create mount point");
-
-	rv = rtems_fsmount( test_sd_card_fs_table, sizeof( test_sd_card_fs_table) / sizeof( test_sd_card_fs_table [0]), NULL);
-	RTEMS_CHECK_RV_TASK( rv, "Mount file systems");
-
-	/*rv = test_sd_card_print_dir( TEST_SD_CARD_MOUNT_POINT, 0); */
-	/*RTEMS_CHECK_RV_TASK( rv, "Print directory"); */
+	rv = test_sd_card_print_dir( TEST_SD_CARD_MOUNT_POINT, 0);
+	RTEMS_CHECK_RV_TASK( rv, "Print directory");
+
+	(void) rtems_task_delete( RTEMS_SELF);
 
 	rv = mkdir( TEST_SD_CARD_DIRECTORY, S_IRWXU);
@@ -524,4 +499,6 @@
 	RTEMS_CHECK_RV_TASK( rv, "Print directory");
 
+	(void) rtems_task_delete( RTEMS_SELF);
+
 
 	#if 0
@@ -562,7 +539,8 @@
 	#endif
 
-	sc = rtems_task_delete( RTEMS_SELF);
-	RTEMS_CHECK_SC_TASK( sc, "rtems_task_delete");
-}
+	(void) rtems_task_delete( RTEMS_SELF);
+}
+
+#endif
 
 #define ITER 4
@@ -572,23 +550,33 @@
 static char outbuf [BUFSIZE];
 
+static void test_mpc55xx_edma_done( mpc55xx_edma_channel_entry *e, uint32_t error_status)
+{
+	rtems_semaphore_release( e->id);
+
+	if (error_status != 0) {
+		printk( "%s: Error status: 0x%08x\n", __func__, error_status);
+	}
+}
+
 static rtems_status_code test_mpc55xx_edma(void)
 {
 	rtems_status_code sc = RTEMS_SUCCESSFUL;
-	int rv = 0;
-	int channel = 0;
-	uint32_t error_status = 0;
-	rtems_id transfer_update;
+	mpc55xx_edma_channel_entry e = {
+		.channel = 0,
+		.done = test_mpc55xx_edma_done,
+		.id = RTEMS_ID_NONE
+	};
 
 	sc = rtems_semaphore_create (
 		rtems_build_name ( 'T', 'S', 'T', 'C'),
 		0,
-		RTEMS_SIMPLE_BINARY_SEMAPHORE | RTEMS_INHERIT_PRIORITY | RTEMS_PRIORITY,
+		RTEMS_SIMPLE_BINARY_SEMAPHORE | RTEMS_PRIORITY,
 		RTEMS_NO_PRIORITY,
-		&transfer_update
+		&e.id
 	);
 	RTEMS_CHECK_SC( sc, "rtems_semaphore_create");
 
-	rv = mpc55xx_edma_obtain_channel( channel, &error_status, transfer_update);
-	RTEMS_CHECK_RV( rv, "mpc55xx_edma_obtain_channel");
+	sc = mpc55xx_edma_obtain_channel( &e);
+	RTEMS_CHECK_RV( sc, "mpc55xx_edma_obtain_channel");
 
 	int i = 0;
@@ -600,26 +588,26 @@
 	rtems_cache_flush_multiple_data_lines( outbuf, BUFSIZE);
 
-	struct tcd_t tcd = MPC55XX_EDMA_TCD_DEFAULT;
+	struct tcd_t tcd = EDMA_TCD_DEFAULT;
 	tcd.SADDR = (uint32_t) &inbuf;
 	tcd.DADDR = (uint32_t) &outbuf;
 	tcd.NBYTES = BUFSIZE / ITER;
 	tcd.SLAST = -BUFSIZE;
-	tcd.CITER = ITER;
-	tcd.BITER = ITER;
-	tcd.INT_HALF = 1;
-
-	EDMA.TCD [channel] = tcd;
+	tcd.CDF.B.CITER = ITER;
+	tcd.BMF.B.BITER = ITER;
+	tcd.BMF.B.INT_HALF = 1;
+
+	EDMA.TCD [e.channel] = tcd;
 
 	while (1) {
 		while (1) {
-			if (EDMA.TCD [channel].DONE == 1) {
-				EDMA.TCD [channel].DONE = 0;
+			if (EDMA.TCD [e.channel].BMF.B.DONE == 1) {
+				EDMA.TCD [e.channel].BMF.B.DONE = 0;
 				printk( "%s: Done\n", __func__);
 				break;
-			} else if (EDMA.TCD [channel].ACTIVE == 0) {
-				EDMA.SSBR.R = channel;
-				printk( "%s: Start: %i (%i)\n", __func__, EDMA.TCD [channel].CITER, EDMA.TCD [channel].BITER);
+			} else if (EDMA.TCD [e.channel].BMF.B.ACTIVE == 0) {
+				EDMA.SSBR.R = e.channel;
+				printk( "%s: Start: %i (%i)\n", __func__, EDMA.TCD [e.channel].CDF.B.CITER, EDMA.TCD [e.channel].BMF.B.BITER);
 			}
-			sc = rtems_semaphore_obtain( transfer_update, RTEMS_WAIT, 10);
+			sc = rtems_semaphore_obtain( e.id, RTEMS_WAIT, 10);
 			if (sc == RTEMS_TIMEOUT) {
 				continue;
@@ -627,9 +615,10 @@
 			RTEMS_CHECK_SC( sc, "rtems_semaphore_obtain");
 		}
-		printk( "%s: Error status: 0x%08x\n", __func__, error_status);
-	}
-
-	return sc;
-}
+	}
+
+	return RTEMS_SUCCESSFUL;
+}
+
+#include <stdlib.h>
 
 static unsigned test_mpc55xx_intc_counter = 0;
@@ -668,9 +657,13 @@
 static rtems_task test_mpc55xx_intc( rtems_task_argument arg)
 {
+	rtems_status_code sc = RTEMS_SUCCESSFUL;
+	rtems_irq_connect_data e = {
+		.on = NULL,
+		.off = NULL,
+		.isOn = NULL
+	};
 	volatile int i = 0;
 	int p = 0;
 	unsigned s = 0;
-	rtems_irq_connect_data e;
-	rtems_status_code sc = RTEMS_SUCCESSFUL;
 
 	for (i = MPC55XX_IRQ_SOFTWARE_MIN, p = MPC55XX_INTC_MIN_PRIORITY; i <= MPC55XX_IRQ_SOFTWARE_MAX; ++i, ++p) {
@@ -685,10 +678,10 @@
 
 		e.hdl = test_mpc55xx_intc_handler_2;
-		if (BSP_install_rtems_shared_irq_handler( &e) != RTEMS_SUCCESSFUL) {
+		if (BSP_install_rtems_shared_irq_handler( &e) != 1) {
 			BSP_panic( "Handler install 2 failed");
 		}
 
 		e.hdl = test_mpc55xx_intc_handler_3;
-		if (BSP_install_rtems_shared_irq_handler( &e) != RTEMS_SUCCESSFUL) {
+		if (BSP_install_rtems_shared_irq_handler( &e) != 1) {
 			BSP_panic( "Handler install 3 failed");
 		}
Index: c/src/lib/libcpu/powerpc/ChangeLog
===================================================================
--- c/src/lib/libcpu/powerpc/ChangeLog	(revision 243596d65e9fc5541fc731c8ad7fc3fdc0bcaf9b)
+++ c/src/lib/libcpu/powerpc/ChangeLog	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
@@ -1,2 +1,10 @@
+2009-07-20	Sebastian Huber <sebastian.huber@embedded-brains.de>
+
+	* Makefile.am, preinstall.am: Update for MPC55XX changes.
+	* mpc55xx/emios/emios.c, mpc55xx/include/emios.h: New files.
+	* mpc55xx/dspi/dspi.c, mpc55xx/edma/edma.c, mpc55xx/esci/esci.c,
+	mpc55xx/include/dspi.h, mpc55xx/include/edma.h, mpc55xx/include/irq.h,
+	mpc55xx/include/regs.h, mpc55xx/irq/irq.c: Changes throughout.
+
 2009-05-05	Jennifer Averett <jennifer.averett@OARcorp.com>
 
Index: c/src/lib/libcpu/powerpc/Makefile.am
===================================================================
--- c/src/lib/libcpu/powerpc/Makefile.am	(revision 243596d65e9fc5541fc731c8ad7fc3fdc0bcaf9b)
+++ c/src/lib/libcpu/powerpc/Makefile.am	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
@@ -420,4 +420,5 @@
 	mpc55xx/include/dspi.h \
 	mpc55xx/include/edma.h \
+	mpc55xx/include/emios.h \
 	mpc55xx/include/mpc55xx.h \
 	mpc55xx/include/esci.h \
@@ -434,10 +435,15 @@
 mpc55xx_fec_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
 
-# EMDA
+# eDMA
 noinst_PROGRAMS += mpc55xx/edma.rel
 mpc55xx_edma_rel_SOURCES = mpc55xx/edma/edma.c
 mpc55xx_edma_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
 
-# ESCI
+# eMIOS
+noinst_PROGRAMS += mpc55xx/emios.rel
+mpc55xx_emios_rel_SOURCES = mpc55xx/emios/emios.c
+mpc55xx_emios_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
+
+# eSCI
 noinst_PROGRAMS += mpc55xx/esci.rel
 mpc55xx_esci_rel_SOURCES = mpc55xx/esci/esci.c
Index: c/src/lib/libcpu/powerpc/mpc55xx/dspi/dspi.c
===================================================================
--- c/src/lib/libcpu/powerpc/mpc55xx/dspi/dspi.c	(revision 243596d65e9fc5541fc731c8ad7fc3fdc0bcaf9b)
+++ c/src/lib/libcpu/powerpc/mpc55xx/dspi/dspi.c	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
@@ -21,5 +21,4 @@
 #include <mpc55xx/regs.h>
 #include <mpc55xx/dspi.h>
-#include <mpc55xx/edma.h>
 #include <mpc55xx/mpc55xx.h>
 
@@ -112,4 +111,13 @@
 };
 
+static void mpc55xx_dspi_edma_done( mpc55xx_edma_channel_entry *e, uint32_t error_status)
+{
+	rtems_semaphore_release( e->id);
+
+	if (error_status != 0) {
+		RTEMS_SYSLOG_ERROR( "eDMA error: 0x%08x\n", error_status);
+	}
+}
+
 static mpc55xx_dspi_baudrate_scaler_entry mpc55xx_dspi_search_baudrate_scaler( uint32_t scaler, int min, int mid, int max)
 {
@@ -152,5 +160,5 @@
 	union DSPI_CTAR_tag ctar = MPC55XX_ZERO_FLAGS;
 	union DSPI_RSER_tag rser = MPC55XX_ZERO_FLAGS;
-	struct tcd_t tcd_push = MPC55XX_EDMA_TCD_DEFAULT;
+	struct tcd_t tcd_push = EDMA_TCD_DEFAULT;
 	int i = 0;
 
@@ -159,12 +167,12 @@
 		rtems_build_name ( 'S', 'P', 'I', 'R'),
 		0,
-		RTEMS_SIMPLE_BINARY_SEMAPHORE | RTEMS_INHERIT_PRIORITY | RTEMS_PRIORITY,
-		RTEMS_NO_PRIORITY,
-		&e->edma_channel_receive_update
+		RTEMS_SIMPLE_BINARY_SEMAPHORE,
+		0,
+		&e->edma_receive.id
 	);
-	RTEMS_CHECK_SC( sc, "Create receive update semaphore");
-
-	sc = mpc55xx_edma_obtain_channel( e->edma_channel_receive, &e->edma_channel_receive_error, e->edma_channel_receive_update);
-	RTEMS_CHECK_SC( sc, "Obtain receive eDMA channel");
+	RTEMS_CHECK_SC( sc, "create receive update semaphore");
+
+	sc = mpc55xx_edma_obtain_channel( &e->edma_receive);
+	RTEMS_CHECK_SC( sc, "obtain receive eDMA channel");
 
 	/* eDMA transmit */
@@ -172,27 +180,27 @@
 		rtems_build_name ( 'S', 'P', 'I', 'T'),
 		0,
-		RTEMS_SIMPLE_BINARY_SEMAPHORE | RTEMS_INHERIT_PRIORITY | RTEMS_PRIORITY,
-		RTEMS_NO_PRIORITY,
-		&e->edma_channel_transmit_update
+		RTEMS_SIMPLE_BINARY_SEMAPHORE,
+		0,
+		&e->edma_transmit.id
 	);
-	RTEMS_CHECK_SC( sc, "Create transmit update semaphore");
-
-	sc = mpc55xx_edma_obtain_channel( e->edma_channel_transmit, &e->edma_channel_transmit_error, e->edma_channel_transmit_update);
-	RTEMS_CHECK_SC( sc, "Obtain transmit eDMA channel");
-
-	sc = mpc55xx_edma_obtain_channel( e->edma_channel_push, NULL, RTEMS_ID_NONE);
-	RTEMS_CHECK_SC( sc, "Obtain push eDMA channel");
+	RTEMS_CHECK_SC( sc, "create transmit update semaphore");
+
+	sc = mpc55xx_edma_obtain_channel( &e->edma_transmit);
+	RTEMS_CHECK_SC( sc, "obtain transmit eDMA channel");
+
+	sc = mpc55xx_edma_obtain_channel( &e->edma_push);
+	RTEMS_CHECK_SC( sc, "obtain push eDMA channel");
 
 	tcd_push.SADDR = mpc55xx_dspi_push_data_address( e);
-	tcd_push.SSIZE = 2;
-	tcd_push.SOFF = 0;
+	tcd_push.SDF.B.SSIZE = 2;
+	tcd_push.SDF.B.SOFF = 0;
 	tcd_push.DADDR = (uint32_t) &e->regs->PUSHR.R;
-	tcd_push.DSIZE = 2;
-	tcd_push.DOFF = 0;
+	tcd_push.SDF.B.DSIZE = 2;
+	tcd_push.CDF.B.DOFF = 0;
 	tcd_push.NBYTES = 4;
-	tcd_push.CITER = 1;
-	tcd_push.BITER = 1;
-
-	EDMA.TCD [e->edma_channel_push] = tcd_push;
+	tcd_push.CDF.B.CITER = 1;
+	tcd_push.BMF.B.BITER = 1;
+
+	EDMA.TCD [e->edma_push.channel] = tcd_push;
 
 	/* Module Control Register */
@@ -325,6 +333,4 @@
 	mpc55xx_dspi_bus_entry *e = (mpc55xx_dspi_bus_entry *) bus;
 	union DSPI_CTAR_tag ctar = MPC55XX_ZERO_FLAGS;
-	uint32_t scaler = bsp_clock_speed / mode->baudrate;
-	mpc55xx_dspi_baudrate_scaler_entry bse = mpc55xx_dspi_search_baudrate_scaler( scaler, 0, MPC55XX_DSPI_BAUDRATE_SCALER_TABLE_SIZE / 2, MPC55XX_DSPI_BAUDRATE_SCALER_TABLE_SIZE);
 
 	if (mode->bits_per_char != 8) {
@@ -335,7 +341,4 @@
 
 	ctar.R = e->regs->CTAR [MPC55XX_DSPI_CTAR_DEFAULT].R;
-
-	ctar.B.PBR = bse.pbr;
-	ctar.B.BR = bse.br;
 
 	ctar.B.PCSSCK = 0;
@@ -347,4 +350,14 @@
 	ctar.B.CPOL = mode->clock_inv ? 1 : 0;
 	ctar.B.CPHA = mode->clock_phs ? 1 : 0;
+
+	if (mode->baudrate != e->baud) {
+		uint32_t scaler = bsp_clock_speed / mode->baudrate;
+		mpc55xx_dspi_baudrate_scaler_entry bse = mpc55xx_dspi_search_baudrate_scaler( scaler, 0, MPC55XX_DSPI_BAUDRATE_SCALER_TABLE_SIZE / 2, MPC55XX_DSPI_BAUDRATE_SCALER_TABLE_SIZE);
+
+		ctar.B.PBR = bse.pbr;
+		ctar.B.BR = bse.br;
+
+		e->baud = mode->baudrate;
+	}
 
 	e->regs->CTAR [MPC55XX_DSPI_CTAR_DEFAULT].R = ctar.R;
@@ -364,7 +377,7 @@
  *  out [shape=box,label="Output Buffer"];
  *  edge [color=red,fontcolor=red];
- *  push -> idle_push_data [label="Transmit Request",URL="\ref mpc55xx_dspi_bus_entry::edma_channel_transmit"];
- *  push -> out [label="Transmit Request",URL="\ref mpc55xx_dspi_bus_entry::edma_channel_transmit"];
- *  out -> push_data [label="Channel Link",URL="\ref mpc55xx_dspi_bus_entry::edma_channel_push"];
+ *  push -> idle_push_data [label="Transmit Request",URL="\ref mpc55xx_dspi_bus_entry::edma_transmit"];
+ *  push -> out [label="Transmit Request",URL="\ref mpc55xx_dspi_bus_entry::edma_transmit"];
+ *  out -> push_data [label="Channel Link",URL="\ref mpc55xx_dspi_bus_entry::edma_push"];
  *  edge [color=blue,fontcolor=blue];
  *  out -> push_data [label="Data"];
@@ -381,6 +394,6 @@
  *  in [shape=box,label="Input Buffer"];
  *  edge [color=red,fontcolor=red];
- *  pop -> nirvana [label="Receive Request",URL="\ref mpc55xx_dspi_bus_entry::edma_channel_receive"];
- *  pop -> in [label="Receive Request",URL="\ref mpc55xx_dspi_bus_entry::edma_channel_receive"];
+ *  pop -> nirvana [label="Receive Request",URL="\ref mpc55xx_dspi_bus_entry::edma_receive"];
+ *  pop -> in [label="Receive Request",URL="\ref mpc55xx_dspi_bus_entry::edma_receive"];
  *  edge [color=blue,fontcolor=blue];
  *  pop -> nirvana [label="Data"];
@@ -425,9 +438,9 @@
 		n_c = (int) mpc55xx_cache_aligned_size( in, (size_t) n);
 		if (n_c > EDMA_TCD_BITER_LINKED_SIZE) {
-			RTEMS_SYSLOG_WARNING( "Buffer size out of range, cannot use eDMA\n");
+			RTEMS_SYSLOG_WARNING( "buffer size out of range, cannot use eDMA\n");
 			n_nc = n;
 			n_c = 0;
 		} else if (n_nc + n_c != n) {
-			RTEMS_SYSLOG_WARNING( "Input buffer not proper cache aligned, cannot use eDMA\n");
+			RTEMS_SYSLOG_WARNING( "input buffer not proper cache aligned, cannot use eDMA\n");
 			n_nc = n;
 			n_c = 0;
@@ -511,6 +524,6 @@
 		unsigned char *in_c = in + n_nc;
 		const unsigned char *out_c = out + n_nc;
-		struct tcd_t tcd_transmit = MPC55XX_EDMA_TCD_DEFAULT;
-		struct tcd_t tcd_receive = MPC55XX_EDMA_TCD_DEFAULT;
+		struct tcd_t tcd_transmit = EDMA_TCD_DEFAULT;
+		struct tcd_t tcd_receive = EDMA_TCD_DEFAULT;
 
 		/* Cache operations */
@@ -523,50 +536,50 @@
 			mpc55xx_dspi_store_push_data( e);
 			tcd_transmit.SADDR = mpc55xx_dspi_push_data_address( e);
-			tcd_transmit.SSIZE = 2;
-			tcd_transmit.SOFF = 0;
+			tcd_transmit.SDF.B.SSIZE = 2;
+			tcd_transmit.SDF.B.SOFF = 0;
 			tcd_transmit.DADDR = (uint32_t) push;
-			tcd_transmit.DSIZE = 2;
-			tcd_transmit.DOFF = 0;
+			tcd_transmit.SDF.B.DSIZE = 2;
+			tcd_transmit.CDF.B.DOFF = 0;
 			tcd_transmit.NBYTES = 4;
-			tcd_transmit.CITER = n_c;
-			tcd_transmit.BITER = n_c;
+			tcd_transmit.CDF.B.CITER = n_c;
+			tcd_transmit.BMF.B.BITER = n_c;
 		} else {
-			EDMA.CDSBR.R = e->edma_channel_transmit;
+			EDMA.CDSBR.R = e->edma_transmit.channel;
 			tcd_transmit.SADDR = (uint32_t) out_c;
-			tcd_transmit.SSIZE = 0;
-			tcd_transmit.SOFF = 1;
+			tcd_transmit.SDF.B.SSIZE = 0;
+			tcd_transmit.SDF.B.SOFF = 1;
 			tcd_transmit.DADDR = mpc55xx_dspi_push_data_address( e) + 3;
-			tcd_transmit.DSIZE = 0;
-			tcd_transmit.DOFF = 0;
+			tcd_transmit.SDF.B.DSIZE = 0;
+			tcd_transmit.CDF.B.DOFF = 0;
 			tcd_transmit.NBYTES = 1;
-			tcd_transmit.CITERE_LINK = 1;
-			tcd_transmit.BITERE_LINK = 1;
-			tcd_transmit.MAJORLINKCH = e->edma_channel_push;
-			tcd_transmit.CITER = EDMA_TCD_LINK_AND_BITER( e->edma_channel_push, n_c);
-			tcd_transmit.BITER = EDMA_TCD_LINK_AND_BITER( e->edma_channel_push, n_c);
-			tcd_transmit.MAJORE_LINK = 1;
+			tcd_transmit.CDF.B.CITERE_LINK = 1;
+			tcd_transmit.BMF.B.BITERE_LINK = 1;
+			tcd_transmit.BMF.B.MAJORLINKCH = e->edma_push.channel;
+			tcd_transmit.CDF.B.CITER = EDMA_TCD_LINK_AND_BITER( e->edma_push.channel, n_c);
+			tcd_transmit.BMF.B.BITER = EDMA_TCD_LINK_AND_BITER( e->edma_push.channel, n_c);
+			tcd_transmit.BMF.B.MAJORE_LINK = 1;
 		}
-		tcd_transmit.D_REQ = 1;
-		tcd_transmit.INT_MAJ = 1;
-		EDMA.TCD [e->edma_channel_transmit] = tcd_transmit;
+		tcd_transmit.BMF.B.D_REQ = 1;
+		tcd_transmit.BMF.B.INT_MAJ = 1;
+		EDMA.TCD [e->edma_transmit.channel] = tcd_transmit;
 
 		/* Set receive TCD */
 		if (in == NULL) {
-			tcd_receive.DOFF = 0;
+			tcd_receive.CDF.B.DOFF = 0;
 			tcd_receive.DADDR = mpc55xx_dspi_nirvana_address( e);
 		} else {
-			tcd_receive.DOFF = 1;
+			tcd_receive.CDF.B.DOFF = 1;
 			tcd_receive.DADDR = (uint32_t) in_c;
 		}
 		tcd_receive.SADDR = (uint32_t) pop + 3;
-		tcd_receive.SSIZE = 0;
-		tcd_receive.SOFF = 0;
-		tcd_receive.DSIZE = 0;
+		tcd_receive.SDF.B.SSIZE = 0;
+		tcd_receive.SDF.B.SOFF = 0;
+		tcd_receive.SDF.B.DSIZE = 0;
 		tcd_receive.NBYTES = 1;
-		tcd_receive.D_REQ = 1;
-		tcd_receive.INT_MAJ = 1;
-		tcd_receive.CITER = n_c;
-		tcd_receive.BITER = n_c;
-		EDMA.TCD [e->edma_channel_receive] = tcd_receive;
+		tcd_receive.BMF.B.D_REQ = 1;
+		tcd_receive.BMF.B.INT_MAJ = 1;
+		tcd_receive.CDF.B.CITER = n_c;
+		tcd_receive.BMF.B.BITER = n_c;
+		EDMA.TCD [e->edma_receive.channel] = tcd_receive;
 
 		/* Clear request flags */
@@ -577,26 +590,14 @@
 
 		/* Enable hardware requests */
-		sc = mpc55xx_edma_enable_hardware_requests( e->edma_channel_receive, true);
-		RTEMS_CHECK_SC_RV( sc, "Enable receive hardware requests");
-		sc = mpc55xx_edma_enable_hardware_requests( e->edma_channel_transmit, true);
-		RTEMS_CHECK_SC_RV( sc, "Enable transmit hardware requests");
+		mpc55xx_edma_enable_hardware_requests( e->edma_receive.channel, true);
+		mpc55xx_edma_enable_hardware_requests( e->edma_transmit.channel, true);
 
 		/* Wait for transmit update */
-		sc = rtems_semaphore_obtain( e->edma_channel_transmit_update, RTEMS_WAIT, RTEMS_NO_TIMEOUT);
-		RTEMS_CHECK_SC_RV( sc, "Transmit update");
-		if (e->edma_channel_transmit_error != 0) {
-			RTEMS_SYSLOG_ERROR( "Transmit error status: 0x%08x\n", e->edma_channel_transmit_error);
-			e->edma_channel_transmit_error = 0;
-			return -RTEMS_IO_ERROR;
-		}
+		sc = rtems_semaphore_obtain( e->edma_transmit.id, RTEMS_WAIT, RTEMS_NO_TIMEOUT);
+		RTEMS_CHECK_SC_RV( sc, "transmit update");
 
 		/* Wait for receive update */
-		sc = rtems_semaphore_obtain( e->edma_channel_receive_update, RTEMS_WAIT, RTEMS_NO_TIMEOUT);
-		RTEMS_CHECK_SC_RV( sc, "Receive update");
-		if (e->edma_channel_receive_error != 0) {
-			RTEMS_SYSLOG_ERROR( "Receive error status: 0x%08x\n", e->edma_channel_receive_error);
-			e->edma_channel_receive_error = 0;
-			return -RTEMS_IO_ERROR;
-		}
+		sc = rtems_semaphore_obtain( e->edma_receive.id, RTEMS_WAIT, RTEMS_NO_TIMEOUT);
+		RTEMS_CHECK_SC_RV( sc, "receive update");
 	}
 
@@ -660,5 +661,6 @@
 };
 
-mpc55xx_dspi_bus_entry mpc55xx_dspi_bus_table [MPC55XX_DSPI_NUMBER] = { {
+mpc55xx_dspi_bus_entry mpc55xx_dspi_bus_table [MPC55XX_DSPI_NUMBER] = {
+	{
 		/* DSPI A */
 		.bus = {
@@ -669,14 +671,23 @@
 		.bus_number = 0,
 		.regs = &DSPI_A,
-		.master = 1,
+		.master = true,
 		.push_data = MPC55XX_ZERO_FLAGS,
-		.edma_channel_transmit = 32,
-		.edma_channel_push = 43,
-		.edma_channel_receive = 33,
-		.edma_channel_transmit_update = 0,
-		.edma_channel_receive_update = 0,
-		.edma_channel_transmit_error = 0,
-		.edma_channel_receive_error = 0,
+		.edma_transmit = {
+			.channel = 32,
+			.done = mpc55xx_dspi_edma_done,
+			.id = RTEMS_ID_NONE
+		},
+		.edma_push = {
+			.channel = 43,
+			.done = mpc55xx_dspi_edma_done,
+			.id = RTEMS_ID_NONE
+		},
+		.edma_receive = {
+			.channel = 33,
+			.done = mpc55xx_dspi_edma_done,
+			.id = RTEMS_ID_NONE
+		},
 		.idle_char = 0xffffffff,
+		.baud = 0
 	}, {
 		/* DSPI B */
@@ -688,14 +699,23 @@
 		.bus_number = 0,
 		.regs = &DSPI_B,
-		.master = 1,
+		.master = true,
 		.push_data = MPC55XX_ZERO_FLAGS,
-		.edma_channel_transmit = 12,
-		.edma_channel_push = 10,
-		.edma_channel_receive = 13,
-		.edma_channel_transmit_update = 0,
-		.edma_channel_receive_update = 0,
-		.edma_channel_transmit_error = 0,
-		.edma_channel_receive_error = 0,
+		.edma_transmit = {
+			.channel = 12,
+			.done = mpc55xx_dspi_edma_done,
+			.id = RTEMS_ID_NONE
+		},
+		.edma_push = {
+			.channel = 10,
+			.done = mpc55xx_dspi_edma_done,
+			.id = RTEMS_ID_NONE
+		},
+		.edma_receive = {
+			.channel = 13,
+			.done = mpc55xx_dspi_edma_done,
+			.id = RTEMS_ID_NONE
+		},
 		.idle_char = 0xffffffff,
+		.baud = 0
 	}, {
 		/* DSPI C */
@@ -707,14 +727,23 @@
 		.bus_number = 0,
 		.regs = &DSPI_C,
-		.master = 1,
+		.master = true,
 		.push_data = MPC55XX_ZERO_FLAGS,
-		.edma_channel_transmit = 14,
-		.edma_channel_push = 11,
-		.edma_channel_receive = 15,
-		.edma_channel_transmit_update = 0,
-		.edma_channel_receive_update = 0,
-		.edma_channel_transmit_error = 0,
-		.edma_channel_receive_error = 0,
+		.edma_transmit = {
+			.channel = 14,
+			.done = mpc55xx_dspi_edma_done,
+			.id = RTEMS_ID_NONE
+		},
+		.edma_push = {
+			.channel = 11,
+			.done = mpc55xx_dspi_edma_done,
+			.id = RTEMS_ID_NONE
+		},
+		.edma_receive = {
+			.channel = 15,
+			.done = mpc55xx_dspi_edma_done,
+			.id = RTEMS_ID_NONE
+		},
 		.idle_char = 0xffffffff,
+		.baud = 0
 	}, {
 		/* DSPI D */
@@ -726,14 +755,23 @@
 		.bus_number = 0,
 		.regs = &DSPI_D,
-		.master = 1,
+		.master = true,
 		.push_data = MPC55XX_ZERO_FLAGS,
-		.edma_channel_transmit = 16,
-		.edma_channel_push = 18,
-		.edma_channel_receive = 17,
-		.edma_channel_transmit_update = 0,
-		.edma_channel_receive_update = 0,
-		.edma_channel_transmit_error = 0,
-		.edma_channel_receive_error = 0,
+		.edma_transmit = {
+			.channel = 16,
+			.done = mpc55xx_dspi_edma_done,
+			.id = RTEMS_ID_NONE
+		},
+		.edma_push = {
+			.channel = 18,
+			.done = mpc55xx_dspi_edma_done,
+			.id = RTEMS_ID_NONE
+		},
+		.edma_receive = {
+			.channel = 17,
+			.done = mpc55xx_dspi_edma_done,
+			.id = RTEMS_ID_NONE
+		},
 		.idle_char = 0xffffffff,
-	},
+		.baud = 0
+	}
 };
